<template>
  <dashboard-layout>
    <FormData :productData="productData" />
  </dashboard-layout>
</template>

<script>
import FormData from "../../components/product/data/FormData.vue";
import productService from "../../services/productService";

export default {
  props: {
    productId: {
      type: String,
      required: false,
      default: null,
    },
  },
  components: {
    FormData,
  },
  data() {
    return {
      productData: {
        productId: "",
        productName: "",
        productPrice: "",
        productImage: "",
        description: "",
        isSales: "",
      },
    };
  },
  methods: {
    async fetchDetailData(id) {
      this.$store.commit("loading", true);
      await productService
        .getById(id)
        .then((response) => {
          this.$store.commit("loading", false);
          this.productData = response.data;
        })
        .catch((error) => {
          this.$store.commit("loading", false);
          let msgError = "";
          if (error.response.status === 422) {
            const dataErrors = error.response.data.errors;
            let errors = [];
            for (const [key, value] of Object.entries(dataErrors)) {
              errors.push(value);
            }
            msgError = errors.toString();
          } else {
            msgError = error.response.data.message;
          }
          this.$store.commit("showMessageError", msgError);
        });
    },
  },
  async created() {
    if (this.productId) {
      await this.fetchDetailData(this.productId);
    }
  },
};
</script>
